// This file is automatically generated from ncp.pac.

#include "ncp_pac.h"

namespace BinPAC {

ncp_request::ncp_request(int arg_length)
	{
	length_ = arg_length;
	function_ = 0;
	subfunction_ = 0;
	make_array(data_, 0);
	}

ncp_request::~ncp_request()
	{
	delete_array(data_);
	}

int ncp_request::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Parse "data"
	int t_data__arraylength = length();
	int t_data__size = 1 * t_data__arraylength;
	// Checking out-of-bound for "ncp_request:data"
	if ( t_begin_of_data + (t_data__size) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("ncp_request:data",
			(0) + (t_data__size), 
			(t_end_of_data) - (t_begin_of_data));
		}
	make_array<uint8>(data_, t_data__arraylength);
	const uint8* t_data__elem__data = t_begin_of_data;
	for ( int t_data__elem__it = 0; 
		t_data__elem__it < t_data__arraylength; 
		++t_data__elem__it )
		{
		uint8 t_data__elem;
		t_data__elem = *((uint8 *) (t_data__elem__data));
		data_.v[t_data__elem__it] = t_data__elem;
		t_data__elem__data += 1;
		}
	function_ = length() > 0 ? data()[0] : 0;
	
	subfunction_ = length() > 1 ? data()[1] : 0;
	
	// Parse "data"
	
	const uint8* const t_dataptr_after_data = t_begin_of_data + (t_data__size);
	int t_val__size = t_dataptr_after_data - t_begin_of_data;
	return t_val__size;
	}

ncp_reply::ncp_reply(int arg_length)
	{
	length_ = arg_length;
	completion_code_ = 0;
	conn_status_ = 0;
	make_array(data_, 0);
	}

ncp_reply::~ncp_reply()
	{
	delete_array(data_);
	}

int ncp_reply::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "ncp_reply:conn_status"
	if ( (t_begin_of_data + 1) + (1) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("ncp_reply:conn_status",
			(1) + (1), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "completion_code"
	completion_code_ = *((uint8 *) (t_begin_of_data));
	
	// Parse "conn_status"
	conn_status_ = *((uint8 *) ((t_begin_of_data + 1)));
	
	// Parse "data"
	int t_data__arraylength = length() - 2;
	int t_data__size = 1 * t_data__arraylength;
	// Checking out-of-bound for "ncp_reply:data"
	if ( (t_begin_of_data + 2) + (t_data__size) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("ncp_reply:data",
			(2) + (t_data__size), 
			(t_end_of_data) - (t_begin_of_data));
		}
	make_array<uint8>(data_, t_data__arraylength);
	const uint8* t_data__elem__data = (t_begin_of_data + 2);
	for ( int t_data__elem__it = 0; 
		t_data__elem__it < t_data__arraylength; 
		++t_data__elem__it )
		{
		uint8 t_data__elem;
		t_data__elem = *((uint8 *) (t_data__elem__data));
		data_.v[t_data__elem__it] = t_data__elem;
		t_data__elem__data += 1;
		}
	
	const uint8* const t_dataptr_after_data = (t_begin_of_data + 2) + (t_data__size);
	int t_val__size = t_dataptr_after_data - t_begin_of_data;
	return t_val__size;
	}

ncp_frame::ncp_frame(int arg_is_orig, int arg_length)
	{
	is_orig_ = arg_is_orig;
	length_ = arg_length;
	frame_type_ = 0;
	seq_ = 0;
	conn_low_ = 0;
	task_ = 0;
	conn_high_ = 0;
	body_length_ = 0;
	body_case_index_ = -1;
	}

ncp_frame::~ncp_frame()
	{
	switch ( body_case_index() )
		{
		case 1:
			// Clean up "request"
			{
			delete body_.request_;
			}
			break;
		case 0:
			// Clean up "reply"
			{
			delete body_.reply_;
			}
			break;
		}
	}

int ncp_frame::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "ncp_frame:conn_high"
	if ( (t_begin_of_data + 5) + (1) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("ncp_frame:conn_high",
			(5) + (1), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "frame_type"
	frame_type_ = UnMarshall<uint16>(t_begin_of_data, frame_type_, t_byteorder);
	
	// Parse "seq"
	seq_ = *((uint8 *) ((t_begin_of_data + 2)));
	
	// Parse "conn_low"
	conn_low_ = *((uint8 *) ((t_begin_of_data + 3)));
	
	// Parse "task"
	task_ = *((uint8 *) ((t_begin_of_data + 4)));
	
	// Parse "conn_high"
	conn_high_ = *((uint8 *) ((t_begin_of_data + 5)));
	
	body_length_ = length() - 6;
	
	// Parse "body"
	int t_body__size;
	body_case_index_ = is_orig();
	switch ( body_case_index() )
		{
		case 1:
			// Parse "request"
			{
			body_.request_ = new ncp_request(body_length());
			int t_request__size = 
				body_.request_->parse((t_begin_of_data + 6), t_end_of_data, bigendian);
			t_body__size = t_request__size;
			}
			break;
		case 0:
			// Parse "reply"
			{
			body_.reply_ = new ncp_reply(body_length());
			int t_reply__size = 
				body_.reply_->parse((t_begin_of_data + 6), t_end_of_data, bigendian);
			t_body__size = t_reply__size;
			}
			break;
		default:
			throw ExceptionInvalidCaseIndex("ncp_frame", body_case_index());
			break;
		}
	
	const uint8* const t_dataptr_after_body = (t_begin_of_data + 6) + (t_body__size);
	int t_val__size = t_dataptr_after_body - t_begin_of_data;
	return t_val__size;
	}

ncp_over_tcpip_req_hdr::ncp_over_tcpip_req_hdr()
	{
	version_ = 0;
	reply_buf_size_ = 0;
	}

ncp_over_tcpip_req_hdr::~ncp_over_tcpip_req_hdr()
	{
	}

int ncp_over_tcpip_req_hdr::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "ncp_over_tcpip_req_hdr:val"
	if ( t_begin_of_data + (8) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("ncp_over_tcpip_req_hdr:val",
			(0) + (8), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "version"
	version_ = UnMarshall<uint32>(t_begin_of_data, version_, t_byteorder);
	
	// Parse "reply_buf_size"
	reply_buf_size_ = UnMarshall<uint32>((t_begin_of_data + 4), reply_buf_size_, t_byteorder);
	
	return 8;
	}

ncp_over_tcpip_frame::ncp_over_tcpip_frame(int arg_is_orig)
	{
	is_orig_ = arg_is_orig;
	signature_ = 0;
	length_ = 0;
	aux_case_index_ = -1;
	ncp_ = 0;
	}

ncp_over_tcpip_frame::~ncp_over_tcpip_frame()
	{
	switch ( aux_case_index() )
		{
		case 1:
			// Clean up "aux_req"
			{
			delete aux_.aux_req_;
			}
			break;
		case 0:
			// Clean up "aux_reply"
			{
			}
			break;
		}
	delete ncp_;
	}

int ncp_over_tcpip_frame::parse(const uint8* const t_begin_of_data, const uint8* const t_end_of_data, int t_byteorder)
	{
	// Checking out-of-bound for "ncp_over_tcpip_frame:length"
	if ( (t_begin_of_data + 4) + (4) > t_end_of_data )
		{
		// Handle out-of-bound condition
		throw ExceptionOutOfBound("ncp_over_tcpip_frame:length",
			(4) + (4), 
			(t_end_of_data) - (t_begin_of_data));
		}
	// Parse "signature"
	byteorder_ = bigendian;
	signature_ = UnMarshall<uint32>(t_begin_of_data, signature_, byteorder());
	
	// Parse "length"
	length_ = UnMarshall<uint32>((t_begin_of_data + 4), length_, byteorder());
	
	// Parse "aux"
	int t_aux__size;
	aux_case_index_ = is_orig();
	switch ( aux_case_index() )
		{
		case 1:
			// Parse "aux_req"
			{
			aux_.aux_req_ = new ncp_over_tcpip_req_hdr();
			aux_.aux_req_->parse((t_begin_of_data + 8), t_end_of_data, byteorder());
			t_aux__size = 8;
			}
			break;
		case 0:
			// Parse "aux_reply"
			{
			// Checking out-of-bound for "ncp_over_tcpip_frame:aux_reply"
			if ( (t_begin_of_data + 8) + (0) > t_end_of_data )
				{
				// Handle out-of-bound condition
				throw ExceptionOutOfBound("ncp_over_tcpip_frame:aux_reply",
					(8) + (0), 
					(t_end_of_data) - (t_begin_of_data));
				}
			t_aux__size = 0;
			}
			break;
		default:
			throw ExceptionInvalidCaseIndex("ncp_over_tcpip_frame", aux_case_index());
			break;
		}
	
	const uint8* const t_dataptr_after_aux = (t_begin_of_data + 8) + (t_aux__size);
	// Parse "ncp"
	ncp_ = new ncp_frame(is_orig(), length() - (t_dataptr_after_aux - t_begin_of_data));
	int t_ncp__size = 
		ncp_->parse(t_dataptr_after_aux, t_end_of_data, byteorder());
	
	const uint8* const t_dataptr_after_ncp = t_dataptr_after_aux + (t_ncp__size);
	int t_val__size = t_dataptr_after_ncp - t_begin_of_data;
	return t_val__size;
	}

} /* namespace BinPAC */
